/*******************************************************
This program was created by the
CodeWizardAVR V3.12 Advanced
Automatic Program Generator
 Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : IRContr5
Version : 1
Date    : 05.03.2016
Author  : Alexey
Company : TOR
Comments: 


Chip type               : ATtiny44A
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 64
*******************************************************/

/****************************************************
PB0                  1.  
PA0-PA7                (  -      +5V         
PB1                  
PB2 (INT0)         
*****************************************************/
#include <tiny44a.h>
#include <delay.h>

// Declare your global variables here
#pragma uchar-

typedef unsigned char   BYTE;
typedef unsigned int    WORD;
typedef unsigned long   DWORD;

#define IRbut_tab_size 8   //-   
#define IRIn     PINB.2
#define LED      PORTB.1

BYTE mode = 1;              //  : 
/******************************************
   2 -      
******************************************/

bit RXend_bit;                //     
BYTE IR_count;                // -   
BYTE IR_i;                    //,     
WORD custom_code;             //  
eeprom WORD custom_code_eep = 0x10EF;
BYTE data_code;               // 
BYTE IRbut_tab[IRbut_tab_size]; //  
eeprom BYTE IRbut_tab_eep[IRbut_tab_size] = {0x00,0x80,0x40,0xC0,0x20,0xA0,0x60,0xE0}; //1-8

//   number 
void led_blink (BYTE number)
{
  BYTE i;
  for (i=0; i<number; i++)
    {
      LED = 1;
      delay_ms (100);
      LED = 0;
      delay_ms (400);
    }
}
//   
//      
// Pin change 8-11 interrupt service routine
interrupt [PC_INT1] void pin_change_isr1(void) {}

//   
//    Timer0 Ft=8/256 -> T=32us
//for NEC format  
//0       0.5625ms  14...22                         
//1       1.6875ms  42...64                   
//kept pr 2.25ms    56...84
//start   4.5ms     112...170
interrupt [EXT_INT0] void ext_int0_isr(void)
{
 BYTE tau = TCNT0;
  TCNT0 = 0;                //  
  
  if (IRIn==0)              //    
    { 
      if (TIFR0&(1<<TOV0))  // 0  (. "1"  IRIn   8.192ms)
        {                   //                         
          IR_count = 0;     //  -  
        }        
      else if ((IR_count==0)&&(tau>55)&&(tau<85)) //   
        {
          IR_i = 0;         //   130ms  
        }      
      else if ((IR_count>0)&&(((tau>13)&&(tau<23))||((tau>41)&&(tau<65))))  //      . . 0  1
        { 
          if (IR_count==32) RXend_bit = 1;  //     32-            
          else
            {     
              if (IR_count<17)      //  
                {
                  custom_code <<= 1;
                  if (tau>41) custom_code|=1; // 1?
                }     
              else if (IR_count<25) // 
                {
                  data_code <<= 1;
                  if (tau>41) data_code|=1;   // 1?
                }               
              IR_count++;
            }                                               
        }        
      else                                  //      4.5ms     
        { 
          custom_code = 0xFFFE;
          data_code = 0xFE;
          RXend_bit = 0;                            //   
          if ((IR_count==0)&&(tau>111)&&(tau<171))  //   
            {               
              IR_count = 1;
              IR_i = 0;                             //  130
            }
          else IR_count = 0;
        }                              
    }
  TIFR0|=(1<<TOV0); //   ( . 1)
}

void main(void)
{
// Declare your local variables here
BYTE i;
BYTE ii = 0;

BYTE button;
BYTE t_pressed = 0; //   

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=(1<<CLKPCE);
CLKPR=(0<<CLKPCE) | (0<<CLKPS3) | (0<<CLKPS2) | (0<<CLKPS1) | (0<<CLKPS0);
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port A initialization
// Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In 
DDRA=(0<<DDA7) | (0<<DDA6) | (0<<DDA5) | (0<<DDA4) | (0<<DDA3) | (0<<DDA2) | (0<<DDA1) | (0<<DDA0);
// State: Bit7=T Bit6=T Bit5=P Bit4=P Bit3=P Bit2=P Bit1=P Bit0=P 
PORTA=(0<<PORTA7) | (0<<PORTA6) | (1<<PORTA5) | (1<<PORTA4) | (1<<PORTA3) | (1<<PORTA2) | (1<<PORTA1) | (1<<PORTA0);

// Port B initialization
// Function: Bit3=In Bit2=In Bit1=Out Bit0=In 
DDRB=(0<<DDB3) | (0<<DDB2) | (1<<DDB1) | (0<<DDB0);
// State: Bit3=T Bit2=P Bit1=0 Bit0=P 
PORTB=(0<<PORTB3) | (1<<PORTB2) | (0<<PORTB1) | (1<<PORTB0);

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 31,250 kHz
// Mode: Normal top=0xFF
// OC0A output: Disconnected
// OC0B output: Disconnected
// Timer Period: 8,192 ms
TCCR0A=(0<<COM0A1) | (0<<COM0A0) | (0<<COM0B1) | (0<<COM0B0) | (0<<WGM01) | (0<<WGM00);
TCCR0B=(0<<WGM02) | (1<<CS02) | (0<<CS01) | (0<<CS00);
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Any change
// Interrupt on any change on pins PCINT0-7: Off
// Interrupt on any change on pins PCINT8-11: On
MCUCR=(0<<ISC01) | (1<<ISC00);
PCMSK1=(0<<PCINT11) | (0<<PCINT10) | (0<<PCINT9) | (1<<PCINT8);
GIMSK=(1<<INT0) | (1<<PCIE1) | (0<<PCIE0);
GIFR=(1<<INTF0) | (1<<PCIF1) | (0<<PCIF0);

// Analog Comparator initialization
// Analog Comparator: Off
// The Analog Comparator's positive input is
// connected to the AIN0 pin
// The Analog Comparator's negative input is
// connected to the AIN1 pin
ACSR=(1<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);

while (!(PINB&1))  //   1
  {         
    if (++t_pressed==200) //  4 
      {                                                                
        mode = 2;         //   
        LED = 1;          // 
        led_blink (3);    // 3   
      }
    if (t_pressed==210) t_pressed--;                              
    delay_ms (20);             
  }
if (mode==2)              //      
  {    
    for (i=0; i<IRbut_tab_size; i++)
      {
        #asm("sei")
        while ((!RXend_bit)&&(PINB&1)); //         1
        if (RXend_bit)                  //   
          { 
            #asm("cli")
            custom_code_eep = custom_code;
            IRbut_tab_eep[i] = data_code;
            RXend_bit = 0;                            
          }              
        else                            // -   1 
          {
            IRbut_tab_eep[i] = 0xFF;    // 
            while (!(PINB&1));          //  1
            delay_ms (40);              //
          }
        led_blink (i+1);                //               
      }                     
  }               

for (i=0; i<IRbut_tab_size; i++) IRbut_tab[i] = IRbut_tab_eep[i];   //   
          
while (1)
  {     
    custom_code = 0xFFFE;   //  
    data_code = 0xFE;       // 
    t_pressed = 0;
    RXend_bit = 0;          //   
    
    DDRA  = 0x00;          // 1-8  
    PORTA = 0xFF;          //  
    
    MCUCR = (1<<SE) | (1<<SM1) | (0<<SM0) | (0<<ISC01) | (0<<ISC00); //   sleep/power down,       INT0()
    #asm("sei")
     
    LED = 0;                                  
    #asm("sleep");
    LED = 1;           
    
    MCUCR = (0<<SE) | (0<<SM1) | (0<<SM0) | (0<<ISC01) | (1<<ISC00);  //   sleep ( ), any logical change on INT0 interrupt
    
    for (IR_i=0; IR_i<130; IR_i++)      // 130ms          
      {                                 // IR_I=110-112 (110ms)
        delay_ms (1);           
        button = (~PINB&0x01);  //            
        if (button)             //    
          {   
            IR_i = 0;           //  130
            data_code = 0xFE;   //  
          }                                                   
        else if (!RXend_bit)                      
          { 
            ii = 0;                         //  10
            t_pressed = 0;
          }  
        if (++ii==10)                       //  10ms  t_pressed
          { 
            ii = 0;
            if (((RXend_bit)&&(custom_code==custom_code_eep))||button)  //       
              {           
                for (i=0; i<IRbut_tab_size; i++)  //  
                  { 
                    if (data_code==IRbut_tab[i]) break;    
                    if (i<1)                    //  :)
                      {
                        if (button==(1<<i)) break;
                      }                                                                  
                  }                                                                            
                if (++t_pressed==1)       //  ?
                  {                      
                    ;
                  }
                if ((t_pressed==1)||(t_pressed==70))      //     0.7?
                  { 
                    if (i<8)              //  1?
                      {
                        PORTA = ~(1<<i);  //   "0"
                        DDRA  = (1<<i);   //                       
                      }                                                                                                               
                                      
                    if (t_pressed!=1) t_pressed = 60;                        
                  }                                                           
                GIFR |= (1<<PCIF1);      //     ( .1)          
              }                                                                                           
          }                                           
      }
  }                
}