
;CodeVisionAVR C Compiler V3.12 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Release
;Chip type              : ATtiny44A
;Program type           : Application
;Clock frequency        : 8,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 64 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATtiny44A
	#pragma AVRPART MEMORY PROG_FLASH 4096
	#pragma AVRPART MEMORY EEPROM 256
	#pragma AVRPART MEMORY INT_SRAM SIZE 256
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E

	.EQU WDTCSR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x13
	.EQU GPIOR1=0x14
	.EQU GPIOR2=0x15

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x015F
	.EQU __DSTACK_SIZE=0x0040
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	RCALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _mode=R3
	.DEF _IR_count=R2
	.DEF _IR_i=R5
	.DEF _custom_code=R6
	.DEF _custom_code_msb=R7
	.DEF _data_code=R4

;GPIOR0-GPIOR2 INITIALIZATION VALUES
	.EQU __GPIOR0_INIT=0x00
	.EQU __GPIOR1_INIT=0x00
	.EQU __GPIOR2_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP 0x00
	RJMP _pin_change_isr1
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

;GLOBAL REGISTER VARIABLES INITIALIZATION
__REG_VARS:
	.DB  0x1


__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x03
	.DW  __REG_VARS*2

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	;__GPIOR1_INIT = __GPIOR0_INIT
	OUT  GPIOR1,R30
	;__GPIOR2_INIT = __GPIOR0_INIT
	OUT  GPIOR2,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xA0

	.CSEG
;/*******************************************************
;This program was created by the
;CodeWizardAVR V3.12 Advanced
;Automatic Program Generator
; Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : IRContr5
;Version : 1
;Date    : 05.03.2016
;Author  : Alexey
;Company : TOR
;Comments:
;
;
;Chip type               : ATtiny44A
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Tiny
;External RAM size       : 0
;Data Stack size         : 64
;*******************************************************/
;
;/****************************************************
;PB0                  1.  
;PA0-PA7                (  -      +5V
;PB1                  
;PB2 (INT0)         
;*****************************************************/
;#include <tiny44a.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x18
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;
;// Declare your global variables here
;#pragma uchar-
;
;typedef unsigned char   BYTE;
;typedef unsigned int    WORD;
;typedef unsigned long   DWORD;
;
;#define IRbut_tab_size 8   //-   
;#define IRIn     PINB.2
;#define LED      PORTB.1
;
;BYTE mode = 1;              //  :
;/******************************************
;   2 -    
;******************************************/
;
;bit RXend_bit;                //     
;BYTE IR_count;                // -   
;BYTE IR_i;                    //,     
;WORD custom_code;             //  
;eeprom WORD custom_code_eep = 0x10EF;
;BYTE data_code;               // 
;BYTE IRbut_tab[IRbut_tab_size]; //  
;eeprom BYTE IRbut_tab_eep[IRbut_tab_size] = {0x00,0x80,0x40,0xC0,0x20,0xA0,0x60,0xE0}; //1-8
;
;//   number 
;void led_blink (BYTE number)
; 0000 003B {

	.CSEG
_led_blink:
; .FSTART _led_blink
; 0000 003C   BYTE i;
; 0000 003D   for (i=0; i<number; i++)
	ST   -Y,R26
	ST   -Y,R17
;	number -> Y+1
;	i -> R17
	LDI  R17,LOW(0)
_0x4:
	LDD  R30,Y+1
	CP   R17,R30
	BRSH _0x5
; 0000 003E     {
; 0000 003F       LED = 1;
	SBI  0x18,1
; 0000 0040       delay_ms (100);
	LDI  R26,LOW(100)
	RCALL SUBOPT_0x0
; 0000 0041       LED = 0;
	CBI  0x18,1
; 0000 0042       delay_ms (400);
	LDI  R26,LOW(400)
	LDI  R27,HIGH(400)
	RCALL _delay_ms
; 0000 0043     }
	SUBI R17,-1
	RJMP _0x4
_0x5:
; 0000 0044 }
	LDD  R17,Y+0
	ADIW R28,2
	RET
; .FEND
;//   
;//      
;// Pin change 8-11 interrupt service routine
;interrupt [PC_INT1] void pin_change_isr1(void) {}
; 0000 0048 interrupt [4] void pin_change_isr1(void) {}
_pin_change_isr1:
; .FSTART _pin_change_isr1
	RETI
; .FEND
;
;//   
;//    Timer0 Ft=8/256 -> T=32us
;//for NEC format
;//0       0.5625ms  14...22
;//1       1.6875ms  42...64
;//kept pr 2.25ms    56...84
;//start   4.5ms     112...170
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 0052 {
_ext_int0_isr:
; .FSTART _ext_int0_isr
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0053  BYTE tau = TCNT0;
; 0000 0054   TCNT0 = 0;                //  
	ST   -Y,R17
;	tau -> R17
	IN   R17,50
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 0055 
; 0000 0056   if (IRIn==0)              //    
	SBIC 0x16,2
	RJMP _0xA
; 0000 0057     {
; 0000 0058       if (TIFR0&(1<<TOV0))  // 0  (. "1"  IRIn   8.192ms)
	IN   R30,0x38
	SBRC R30,0
; 0000 0059         {                   //       
; 0000 005A           IR_count = 0;     //  -  
	RJMP _0x66
; 0000 005B         }
; 0000 005C       else if ((IR_count==0)&&(tau>55)&&(tau<85)) //   
	TST  R2
	BRNE _0xE
	CPI  R17,56
	BRLO _0xE
	CPI  R17,85
	BRLO _0xF
_0xE:
	RJMP _0xD
_0xF:
; 0000 005D         {
; 0000 005E           IR_i = 0;         //   130ms
	CLR  R5
; 0000 005F         }
; 0000 0060       else if ((IR_count>0)&&(((tau>13)&&(tau<23))||((tau>41)&&(tau<65))))  //      . ...
	RJMP _0x10
_0xD:
	LDI  R30,LOW(0)
	CP   R30,R2
	BRSH _0x12
	CPI  R17,14
	BRLO _0x13
	CPI  R17,23
	BRLO _0x15
_0x13:
	CPI  R17,42
	BRLO _0x16
	CPI  R17,65
	BRLO _0x15
_0x16:
	RJMP _0x12
_0x15:
	RJMP _0x19
_0x12:
	RJMP _0x11
_0x19:
; 0000 0061         {
; 0000 0062           if (IR_count==32) RXend_bit = 1;  //     32- 
	LDI  R30,LOW(32)
	CP   R30,R2
	BRNE _0x1A
	SBI  0x13,0
; 0000 0063           else
	RJMP _0x1D
_0x1A:
; 0000 0064             {
; 0000 0065               if (IR_count<17)      //  
	LDI  R30,LOW(17)
	CP   R2,R30
	BRSH _0x1E
; 0000 0066                 {
; 0000 0067                   custom_code <<= 1;
	LSL  R6
	ROL  R7
; 0000 0068                   if (tau>41) custom_code|=1; // 1?
	CPI  R17,42
	BRLO _0x1F
	LDI  R30,LOW(1)
	OR   R6,R30
; 0000 0069                 }
_0x1F:
; 0000 006A               else if (IR_count<25) // 
	RJMP _0x20
_0x1E:
	LDI  R30,LOW(25)
	CP   R2,R30
	BRSH _0x21
; 0000 006B                 {
; 0000 006C                   data_code <<= 1;
	LSL  R4
; 0000 006D                   if (tau>41) data_code|=1;   // 1?
	CPI  R17,42
	BRLO _0x22
	LDI  R30,LOW(1)
	OR   R4,R30
; 0000 006E                 }
_0x22:
; 0000 006F               IR_count++;
_0x21:
_0x20:
	INC  R2
; 0000 0070             }
_0x1D:
; 0000 0071         }
; 0000 0072       else                                  //      4.5ms
	RJMP _0x23
_0x11:
; 0000 0073         {
; 0000 0074           custom_code = 0xFFFE;
	RCALL SUBOPT_0x1
; 0000 0075           data_code = 0xFE;
; 0000 0076           RXend_bit = 0;                            //   
	CBI  0x13,0
; 0000 0077           if ((IR_count==0)&&(tau>111)&&(tau<171))  //   
	TST  R2
	BRNE _0x27
	CPI  R17,112
	BRLO _0x27
	CPI  R17,171
	BRLO _0x28
_0x27:
	RJMP _0x26
_0x28:
; 0000 0078             {
; 0000 0079               IR_count = 1;
	LDI  R30,LOW(1)
	MOV  R2,R30
; 0000 007A               IR_i = 0;                             //  130
	CLR  R5
; 0000 007B             }
; 0000 007C           else IR_count = 0;
	RJMP _0x29
_0x26:
_0x66:
	CLR  R2
; 0000 007D         }
_0x29:
_0x23:
_0x10:
; 0000 007E     }
; 0000 007F   TIFR0|=(1<<TOV0); //   ( . 1)
_0xA:
	IN   R30,0x38
	ORI  R30,1
	OUT  0x38,R30
; 0000 0080 }
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
; .FEND
;
;void main(void)
; 0000 0083 {
_main:
; .FSTART _main
; 0000 0084 // Declare your local variables here
; 0000 0085 BYTE i;
; 0000 0086 BYTE ii = 0;
; 0000 0087 
; 0000 0088 BYTE button;
; 0000 0089 BYTE t_pressed = 0; //   
; 0000 008A 
; 0000 008B // Crystal Oscillator division factor: 1
; 0000 008C #pragma optsize-
; 0000 008D CLKPR=(1<<CLKPCE);
;	i -> R17
;	ii -> R16
;	button -> R19
;	t_pressed -> R18
	LDI  R16,0
	LDI  R18,0
	LDI  R30,LOW(128)
	OUT  0x26,R30
; 0000 008E CLKPR=(0<<CLKPCE) | (0<<CLKPS3) | (0<<CLKPS2) | (0<<CLKPS1) | (0<<CLKPS0);
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 008F #ifdef _OPTIMIZE_SIZE_
; 0000 0090 #pragma optsize+
; 0000 0091 #endif
; 0000 0092 
; 0000 0093 // Input/Output Ports initialization
; 0000 0094 // Port A initialization
; 0000 0095 // Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In
; 0000 0096 DDRA=(0<<DDA7) | (0<<DDA6) | (0<<DDA5) | (0<<DDA4) | (0<<DDA3) | (0<<DDA2) | (0<<DDA1) | (0<<DDA0);
	OUT  0x1A,R30
; 0000 0097 // State: Bit7=T Bit6=T Bit5=P Bit4=P Bit3=P Bit2=P Bit1=P Bit0=P
; 0000 0098 PORTA=(0<<PORTA7) | (0<<PORTA6) | (1<<PORTA5) | (1<<PORTA4) | (1<<PORTA3) | (1<<PORTA2) | (1<<PORTA1) | (1<<PORTA0);
	LDI  R30,LOW(63)
	OUT  0x1B,R30
; 0000 0099 
; 0000 009A // Port B initialization
; 0000 009B // Function: Bit3=In Bit2=In Bit1=Out Bit0=In
; 0000 009C DDRB=(0<<DDB3) | (0<<DDB2) | (1<<DDB1) | (0<<DDB0);
	LDI  R30,LOW(2)
	OUT  0x17,R30
; 0000 009D // State: Bit3=T Bit2=P Bit1=0 Bit0=P
; 0000 009E PORTB=(0<<PORTB3) | (1<<PORTB2) | (0<<PORTB1) | (1<<PORTB0);
	LDI  R30,LOW(5)
	OUT  0x18,R30
; 0000 009F 
; 0000 00A0 // Timer/Counter 0 initialization
; 0000 00A1 // Clock source: System Clock
; 0000 00A2 // Clock value: 31,250 kHz
; 0000 00A3 // Mode: Normal top=0xFF
; 0000 00A4 // OC0A output: Disconnected
; 0000 00A5 // OC0B output: Disconnected
; 0000 00A6 // Timer Period: 8,192 ms
; 0000 00A7 TCCR0A=(0<<COM0A1) | (0<<COM0A0) | (0<<COM0B1) | (0<<COM0B0) | (0<<WGM01) | (0<<WGM00);
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 00A8 TCCR0B=(0<<WGM02) | (1<<CS02) | (0<<CS01) | (0<<CS00);
	LDI  R30,LOW(4)
	OUT  0x33,R30
; 0000 00A9 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 00AA OCR0A=0x00;
	OUT  0x36,R30
; 0000 00AB OCR0B=0x00;
	OUT  0x3C,R30
; 0000 00AC 
; 0000 00AD // External Interrupt(s) initialization
; 0000 00AE // INT0: On
; 0000 00AF // INT0 Mode: Any change
; 0000 00B0 // Interrupt on any change on pins PCINT0-7: Off
; 0000 00B1 // Interrupt on any change on pins PCINT8-11: On
; 0000 00B2 MCUCR=(0<<ISC01) | (1<<ISC00);
	LDI  R30,LOW(1)
	OUT  0x35,R30
; 0000 00B3 PCMSK1=(0<<PCINT11) | (0<<PCINT10) | (0<<PCINT9) | (1<<PCINT8);
	OUT  0x20,R30
; 0000 00B4 GIMSK=(1<<INT0) | (1<<PCIE1) | (0<<PCIE0);
	LDI  R30,LOW(96)
	OUT  0x3B,R30
; 0000 00B5 GIFR=(1<<INTF0) | (1<<PCIF1) | (0<<PCIF0);
	OUT  0x3A,R30
; 0000 00B6 
; 0000 00B7 // Analog Comparator initialization
; 0000 00B8 // Analog Comparator: Off
; 0000 00B9 // The Analog Comparator's positive input is
; 0000 00BA // connected to the AIN0 pin
; 0000 00BB // The Analog Comparator's negative input is
; 0000 00BC // connected to the AIN1 pin
; 0000 00BD ACSR=(1<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 00BE 
; 0000 00BF while (!(PINB&1))  //   1
_0x2A:
	SBIC 0x16,0
	RJMP _0x2C
; 0000 00C0   {
; 0000 00C1     if (++t_pressed==200) //  4
	SUBI R18,-LOW(1)
	CPI  R18,200
	BRNE _0x2D
; 0000 00C2       {
; 0000 00C3         mode = 2;         //   
	LDI  R30,LOW(2)
	MOV  R3,R30
; 0000 00C4         LED = 1;          // 
	SBI  0x18,1
; 0000 00C5         led_blink (3);    // 3 
	LDI  R26,LOW(3)
	RCALL _led_blink
; 0000 00C6       }
; 0000 00C7     if (t_pressed==210) t_pressed--;
_0x2D:
	CPI  R18,210
	BRNE _0x30
	SUBI R18,1
; 0000 00C8     delay_ms (20);
_0x30:
	LDI  R26,LOW(20)
	RCALL SUBOPT_0x0
; 0000 00C9   }
	RJMP _0x2A
_0x2C:
; 0000 00CA if (mode==2)              //      
	LDI  R30,LOW(2)
	CP   R30,R3
	BRNE _0x31
; 0000 00CB   {
; 0000 00CC     for (i=0; i<IRbut_tab_size; i++)
	LDI  R17,LOW(0)
_0x33:
	CPI  R17,8
	BRSH _0x34
; 0000 00CD       {
; 0000 00CE         #asm("sei")
	sei
; 0000 00CF         while ((!RXend_bit)&&(PINB&1)); //         1
_0x35:
	SBIC 0x13,0
	RJMP _0x38
	SBIC 0x16,0
	RJMP _0x39
_0x38:
	RJMP _0x37
_0x39:
	RJMP _0x35
_0x37:
; 0000 00D0         if (RXend_bit)                  //   
	SBIS 0x13,0
	RJMP _0x3A
; 0000 00D1           {
; 0000 00D2             #asm("cli")
	cli
; 0000 00D3             custom_code_eep = custom_code;
	MOVW R30,R6
	LDI  R26,LOW(_custom_code_eep)
	LDI  R27,HIGH(_custom_code_eep)
	RCALL __EEPROMWRW
; 0000 00D4             IRbut_tab_eep[i] = data_code;
	RCALL SUBOPT_0x2
	MOV  R30,R4
	RCALL __EEPROMWRB
; 0000 00D5             RXend_bit = 0;
	CBI  0x13,0
; 0000 00D6           }
; 0000 00D7         else                            // -   1
	RJMP _0x3D
_0x3A:
; 0000 00D8           {
; 0000 00D9             IRbut_tab_eep[i] = 0xFF;    // 
	RCALL SUBOPT_0x2
	LDI  R30,LOW(255)
	RCALL __EEPROMWRB
; 0000 00DA             while (!(PINB&1));          //  1
_0x3E:
	SBIS 0x16,0
	RJMP _0x3E
; 0000 00DB             delay_ms (40);              //
	LDI  R26,LOW(40)
	RCALL SUBOPT_0x0
; 0000 00DC           }
_0x3D:
; 0000 00DD         led_blink (i+1);                //
	MOV  R26,R17
	SUBI R26,-LOW(1)
	RCALL _led_blink
; 0000 00DE       }
	SUBI R17,-1
	RJMP _0x33
_0x34:
; 0000 00DF   }
; 0000 00E0 
; 0000 00E1 for (i=0; i<IRbut_tab_size; i++) IRbut_tab[i] = IRbut_tab_eep[i];   //   
_0x31:
	LDI  R17,LOW(0)
_0x42:
	CPI  R17,8
	BRSH _0x43
	RCALL SUBOPT_0x3
	MOVW R0,R30
	RCALL SUBOPT_0x2
	RCALL __EEPROMRDB
	MOVW R26,R0
	ST   X,R30
	SUBI R17,-1
	RJMP _0x42
_0x43:
; 0000 00E3 while (1)
_0x44:
; 0000 00E4   {
; 0000 00E5     custom_code = 0xFFFE;   //  
	RCALL SUBOPT_0x1
; 0000 00E6     data_code = 0xFE;       // 
; 0000 00E7     t_pressed = 0;
	LDI  R18,LOW(0)
; 0000 00E8     RXend_bit = 0;          //   
	CBI  0x13,0
; 0000 00E9 
; 0000 00EA     DDRA  = 0x00;          // 1-8  
	LDI  R30,LOW(0)
	OUT  0x1A,R30
; 0000 00EB     PORTA = 0xFF;          //  
	LDI  R30,LOW(255)
	OUT  0x1B,R30
; 0000 00EC 
; 0000 00ED     MCUCR = (1<<SE) | (1<<SM1) | (0<<SM0) | (0<<ISC01) | (0<<ISC00); //   sleep/power down,  ...
	LDI  R30,LOW(48)
	OUT  0x35,R30
; 0000 00EE     #asm("sei")
	sei
; 0000 00EF 
; 0000 00F0     LED = 0;
	CBI  0x18,1
; 0000 00F1     #asm("sleep");
	sleep
; 0000 00F2     LED = 1;
	SBI  0x18,1
; 0000 00F3 
; 0000 00F4     MCUCR = (0<<SE) | (0<<SM1) | (0<<SM0) | (0<<ISC01) | (1<<ISC00);  //   sleep ( ), any ...
	LDI  R30,LOW(1)
	OUT  0x35,R30
; 0000 00F5 
; 0000 00F6     for (IR_i=0; IR_i<130; IR_i++)      // 130ms        
	CLR  R5
_0x4E:
	LDI  R30,LOW(130)
	CP   R5,R30
	BRLO PC+2
	RJMP _0x4F
; 0000 00F7       {                                 // IR_I=110-112 (110ms)
; 0000 00F8         delay_ms (1);
	LDI  R26,LOW(1)
	RCALL SUBOPT_0x0
; 0000 00F9         button = (~PINB&0x01);  //   
	IN   R30,0x16
	COM  R30
	ANDI R30,LOW(0x1)
	MOV  R19,R30
; 0000 00FA         if (button)             //    
	CPI  R19,0
	BREQ _0x50
; 0000 00FB           {
; 0000 00FC             IR_i = 0;           //  130
	CLR  R5
; 0000 00FD             data_code = 0xFE;   //  
	LDI  R30,LOW(254)
	MOV  R4,R30
; 0000 00FE           }
; 0000 00FF         else if (!RXend_bit)
	RJMP _0x51
_0x50:
	SBIC 0x13,0
	RJMP _0x52
; 0000 0100           {
; 0000 0101             ii = 0;                         //  10
	LDI  R16,LOW(0)
; 0000 0102             t_pressed = 0;
	LDI  R18,LOW(0)
; 0000 0103           }
; 0000 0104         if (++ii==10)                       //  10ms  t_pressed
_0x52:
_0x51:
	SUBI R16,-LOW(1)
	CPI  R16,10
	BRNE _0x53
; 0000 0105           {
; 0000 0106             ii = 0;
	LDI  R16,LOW(0)
; 0000 0107             if (((RXend_bit)&&(custom_code==custom_code_eep))||button)  //        ...
	SBIS 0x13,0
	RJMP _0x55
	LDI  R26,LOW(_custom_code_eep)
	LDI  R27,HIGH(_custom_code_eep)
	RCALL __EEPROMRDW
	CP   R30,R6
	CPC  R31,R7
	BREQ _0x57
_0x55:
	CPI  R19,0
	BREQ _0x54
_0x57:
; 0000 0108               {
; 0000 0109                 for (i=0; i<IRbut_tab_size; i++)  //  
	LDI  R17,LOW(0)
_0x5A:
	CPI  R17,8
	BRSH _0x5B
; 0000 010A                   {
; 0000 010B                     if (data_code==IRbut_tab[i]) break;
	RCALL SUBOPT_0x3
	LD   R30,Z
	CP   R30,R4
	BREQ _0x5B
; 0000 010C                     if (i<1)                    //  :)
	CPI  R17,1
	BRSH _0x5D
; 0000 010D                       {
; 0000 010E                         if (button==(1<<i)) break;
	MOV  R30,R17
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	RCALL __LSLW12
	MOV  R26,R19
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x5B
; 0000 010F                       }
; 0000 0110                   }
_0x5D:
	SUBI R17,-1
	RJMP _0x5A
_0x5B:
; 0000 0111                 if (++t_pressed==1)       //  ?
	SUBI R18,-LOW(1)
; 0000 0112                   {
; 0000 0113                     ;
; 0000 0114                   }
; 0000 0115                 if ((t_pressed==1)||(t_pressed==70))      //     0.7?
	CPI  R18,1
	BREQ _0x61
	CPI  R18,70
	BRNE _0x60
_0x61:
; 0000 0116                   {
; 0000 0117                     if (i<8)              //  1?
	CPI  R17,8
	BRSH _0x63
; 0000 0118                       {
; 0000 0119                         PORTA = ~(1<<i);  //   "0"
	MOV  R30,R17
	LDI  R26,LOW(1)
	RCALL __LSLB12
	COM  R30
	OUT  0x1B,R30
; 0000 011A                         DDRA  = (1<<i);   //  
	MOV  R30,R17
	RCALL __LSLB12
	OUT  0x1A,R30
; 0000 011B                       }
; 0000 011C 
; 0000 011D                     if (t_pressed!=1) t_pressed = 60;
_0x63:
	CPI  R18,1
	BREQ _0x64
	LDI  R18,LOW(60)
; 0000 011E                   }
_0x64:
; 0000 011F                 GIFR |= (1<<PCIF1);      //     ( .1)
_0x60:
	IN   R30,0x3A
	ORI  R30,0x20
	OUT  0x3A,R30
; 0000 0120               }
; 0000 0121           }
_0x54:
; 0000 0122       }
_0x53:
	INC  R5
	RJMP _0x4E
_0x4F:
; 0000 0123   }
	RJMP _0x44
; 0000 0124 }
_0x65:
	RJMP _0x65
; .FEND

	.ESEG
_custom_code_eep:
	.DB  0xEF,0x10

	.DSEG
_IRbut_tab:
	.BYTE 0x8

	.ESEG
_IRbut_tab_eep:
	.DB  0x0,0x80,0x40,0xC0
	.DB  0x20,0xA0,0x60,0xE0

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(65534)
	LDI  R31,HIGH(65534)
	MOVW R6,R30
	MOV  R4,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2:
	MOV  R26,R17
	LDI  R27,0
	SUBI R26,LOW(-_IRbut_tab_eep)
	SBCI R27,HIGH(-_IRbut_tab_eep)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_IRbut_tab)
	SBCI R31,HIGH(-_IRbut_tab)
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSLW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

;END OF CODE MARKER
__END_OF_CODE:
